# CrossUI

CrossUI is a free Cross-Browser Javascript framework with cutting-edge functionality for SPA(Single Page Application) web application.

<strong>Compatible with older browsers, even IE6</strong>

## Features & Resources

  1.  Rich client-side API, works with any backend or static HTML pages.
  2.  Web services (JSON/XML/SOAP) can be directly bound.
  3.  More than 100 components, including Tabs, Dialog, TreeGrid, SVG Shapes, Chart and many other web GUI components.
  4.  Support reusable modules.
  5.  Wide cross-browser compatibility, IE6+, firefox3+, opera9+, safari3+ and Google Chrome.
  6.  Full API Documentation with tons of samples.
  7.  Ever Increasing Code Snippets.
  8.  PHP/C #/JAVA Back-end service codes are available.
  9.  CrossUI Framework is Open Source under LGPL3 license.


## Related tools

These tools (without coding) can reduce development time significantly:

* CrossUI Front-end builder for Github: https://crossui.com/RADGithub <br>
> <b>Create fully interactive web app without writing one line of code, integrated with Github repository</b>
![Builder](https://crossui.com/img/feature-1.png)

* CrossUI Single Page Builder: https://crossui.com/RAD/Builder.html

* CrossUI Embeddable Desginer: https://crossui.com/Designer/

* CrossUI Theme Roller: https://crossui.com/ThemeRoller

* CrossUI Form Builder https://crossui.com/FormBuilder

* CrossUI JSON Editor: https://crossui.com/JSONEditor

* GitHub JSON Editor : https://linb.github.io/GitHub_JSON_Editor
  A tool to edit any JSON file in Github Repo

* GitHub Code Editor : https://linb.github.io/GitHub_Code_Editor
  A tool to edit any code file in  Github Repo

## CDN
* https://cdn.jsdelivr.net/gh/linb/CrossUI@latest/runtime/xui/js/xui-all.js
* https://crossui.com/libs/2.0/js/xui-all.js

## Others
* Examples: https://www.crossui.com/examples.html
* Tutorials: https://www.crossui.com/tutorials.html
* Desktop versions: https://www.crossui.com/download.html
